/* -----------------------------------------------------------------------------
 * std_tuple.i
 *
 * SWIG typemaps for std::tuple
 * ----------------------------------------------------------------------------- */

%include <std_common.i>
%include <exception.i>

// ------------------------------------------------------------------------
// std::tuple
// ------------------------------------------------------------------------

%{
#include <tuple>
%}

namespace std {
  template <typename T1=void, typename T2=void, typename T3=void> 
  struct tuple;

  template <>
  struct tuple<void,void,void> {
  };

  template <typename T1>
  struct tuple<T1, void, void> {
    tuple(T1);
    %extend {
      T1 first() const {
        return std::get<0>(*$self);
      }
    }
  };

  template <typename T1, typename T2>
  struct tuple <T1, T2, void> {
    tuple(T1,T2);
    %extend {
      T1 first() const {
        return std::get<0>(*$self);
      }
      T2 second() const { 
        return std::get<1>(*$self);
      }
    }
  };

  template <typename T1, typename T2, typename T3> 
  struct tuple <T1,T2,T3> {
    tuple(T1,T2,T3);
    %extend {
      T1 first() const {
        return std::get<0>(*$self);
      }
      T2 second() const {
        return std::get<1>(*$self);
      }
      T3 third() const {
        return std::get<2>(*$self);
      }
    }
  };
}
